<template>
  <v-container>
    <div class="d-flex align-center mb-8">
      <h1>ALBUM</h1>
      <h3 class="ml-auto">
        <nuxt-link class="blue--text" to="/favourites"
          >Go to Favourites</nuxt-link
        >
      </h3>
    </div>

    <v-row>
      <v-col lg="6" md="6" sm="12" cols="12">
        <v-autocomplete
          v-model="title_selected"
          :loading="lov_title_select.length === 0"
          :items="lov_title_select"
          item-text="title"
          item-value="title"
          cache-items
          hide-no-data
          hide-details
          label="Select Album Title"
          solo
          clearable
        ></v-autocomplete>
      </v-col>
      <v-col lg="6" md="6" sm="12" cols="12">
        <v-autocomplete
          v-model="user_selected"
          :loading="loading_user"
          :items="datas_user"
          item-text="name"
          item-value="id"
          cache-items
          hide-no-data
          hide-details
          label="Select User"
          solo
          clearable
        ></v-autocomplete>
      </v-col>
    </v-row>

    <AlbumBox
      :datas="datas"
      :datas-user="datas_user"
      :datas-photo="datas_photo"
      :loading="loading"
    />
  </v-container>
</template>

<script>
import AlbumBox from "@/components/AlbumBox";
export default {
  components: {
    AlbumBox
  },
  data() {
    return {
      lov_title_select: [],
      user_selected: null,
      title_selected: null
    };
  },
  computed: {
    datas() {
      if (this.lov_title_select.length === 0) {
        this.lov_title_select = this.$store.get("datas_album");
      }
      return this.$store.get("datas_album");
    },
    loading() {
      return this.$store.get("loading");
    },
    datas_user() {
      return this.$store.get("datas_user");
    },
    loading_user() {
      return this.$store.get("loading_user");
    },
    datas_photo() {
      return this.$store.get("datas_photo");
    },
    loading_photo() {
      return this.$store.get("loading_photo");
    }
  },
  watch: {
    user_selected(val) {
      this.load();
    },
    title_selected(val) {
      this.load();
    }
  },
  created() {
    this.load();
    this.loadUsers();
    this.loadPhotos();
  },
  methods: {
    async load() {
      const params = {
        userId: this.user_selected,
        title: this.title_selected
      };
      this.$store.dispatch("loadAlbums", params);
    },
    loadUsers() {
      this.$store.dispatch("loadUsers", null);
    },
    loadPhotos() {
      this.$store.dispatch("loadPhotos", null);
    }
  }
};
</script>
